function [A,B,Cst] = coef_Calculation_Abs(n1,n2,n3,v1,v2,v3,rv11,rv12,rv13,rv21,rv22,rv23,rv31,rv32,rv33)
%Absolute Cam
A =  n1 .*  rv11 .* v1  ... 
 + n2 .*  rv21 .* v1   ...
 + n3 .*  rv31 .* v1   ...
 - v3 .* n3 .*  rv33   ...
 - v3 .* n2 .*  rv23   ...
 - v3 .* n1 .*  rv13  ... 
 - v2 .* n3 .*  rv32  ... 
 - v2 .* n2 .*  rv22   ...
 - v2 .* n1 .*  rv12 ;

B=   0.2e1 .* v2 .* n1 .* rv13 ... 
+ 0.2e1 .* v2 .* n2 .* rv23 ... 
+ 0.2e1 .* v2 .* n3 .* rv33 ... 
- 0.2e1 .* v3 .* n3 .* rv32 ... 
- 0.2e1 .* v3 .* n2 .* rv22 ... 
- 0.2e1 .* v3 .* n1 .* rv12 ;



Cst= n1 .* rv11 .* v1  ...
 + n2 .* rv21 .* v1  ...
 + n3 .* rv31 .* v1  ...
 + v2 .* n1 .* rv12 ...
 + v2 .* n2 .* rv22  ...
 + v2 .* n3 .* rv32  ...
 + v3 .* n1 .* rv13  ...
 + v3 .* n2 .* rv23  ...
 + v3 .* n3 .* rv33;

A = sum(A);
B = sum(B);
Cst = sum(Cst);


end

