% Generated using GBSolver generator Copyright Martin Bujnak,
% Zuzana Kukelova, Tomas Pajdla CTU Prague 2008.
% 
% Please refer to the following paper, when using this code :
%     Kukelova Z., Bujnak M., Pajdla T., Automatic Generator of Minimal Problem Solvers,
%     ECCV 2008, Marseille, France, October 12-18, 2008

function [qa_1, kr_1] = solver_Direct_Solver_Basic_equation_2C_fast(A_1, B_1, Cst_1, Ai_1, Bi_1, Ci_1, Di_1, Ei_1, Fi_1, Gi_1, Hi_1, Csti_1)

	% precalculate polynomial equations coefficients
	c(1) = A_1;
	c(2) = B_1;
	c(3) = Cst_1;
	c(4) = Ai_1;
	c(5) = Ci_1;
	c(6) = Gi_1;
	c(7) = Fi_1;
	c(8) = Bi_1;
	c(9) = Di_1;
	c(10) = Ei_1;
	c(11) = Hi_1;
	c(12) = Csti_1;

	F1 = zeros(4, 9);
	F1(1) = c(4);
	F1(5) = c(8);
	F1(9) = c(7);
	F1(13) = c(5);
	F1(17) = c(9);
	F1(21) = c(6);
	F1(25) = c(10);
	F1(29) = c(11);
	F1(33) = c(12);
	F1(2) = c(1);
	F1(10) = c(2);
	F1(22) = c(3);
	F1(7) = c(1);
	F1(19) = c(2);
	F1(31) = c(3);
	F1(16) = c(1);
	F1(28) = c(2);
	F1(36) = c(3);
	%F1 = rref(F1);
	F1 = frref(F1);

	F2 = zeros(5, 9);
	F2(1) = F1(11);
	F2(6) = F1(19);
	F2(11) = F1(23);
	F2(16) = F1(27);
	F2(21) = F1(31);
	F2(31) = F1(35);
	F2(2) = c(4);
	F2(7) = c(8);
	F2(12) = c(7);
	F2(17) = c(5);
	F2(22) = c(9);
	F2(27) = c(6);
	F2(32) = c(10);
	F2(37) = c(11);
	F2(42) = c(12);
	F2(8) = F1(6);
	F2(23) = F1(18);
	F2(38) = F1(30);
	F2(14) = F1(11);
	F2(24) = F1(19);
	F2(29) = F1(23);
	F2(34) = F1(27);
	F2(39) = F1(31);
	F2(44) = F1(35);
	F2(20) = c(1);
	F2(35) = c(2);
	F2(45) = c(3);
	%F2 = rref(F2);
	F2 = frref(F2);

	F3 = zeros(5, 9);
	F3(1) = F1(6);
	F3(21) = F1(18);
	F3(36) = F1(30);
	F3(7) = F2(25);
	F3(12) = F2(30);
	F3(22) = F2(35);
	F3(27) = F2(40);
	F3(37) = F2(45);
	F3(8) = F1(11);
	F3(23) = F1(19);
	F3(28) = F1(23);
	F3(33) = F1(27);
	F3(38) = F1(31);
	F3(43) = F1(35);
	F3(19) = c(1);
	F3(34) = c(2);
	F3(44) = c(3);
	F3(25) = F2(25);
	F3(30) = F2(30);
	F3(35) = F2(35);
	F3(40) = F2(40);
	F3(45) = F2(45);
	%F3 = rref(F3);
	F3 = frref(F3);

	M = zeros(2, 6);
	M(3) = F2(25);
	M(5) = F2(30);
	M(7) = F2(35);
	M(9) = F2(40);
	M(11) = F2(45);
	M(2) = F3(13);
	M(6) = F3(28);
	M(8) = F3(33);
	M(10) = F3(38);
	M(12) = F3(43);
	%M = rref(M);
	M = frref(M);

	A = zeros(4);
	amcols = [6 5 4 3];
	A(1, 2) = 1;
	A(2, 4) = 1;
	A(3, :) = -M(2, amcols);
	A(4, :) = -M(1, amcols);

	[V D] = eig(A);
	sol =  V([3, 2],:)./(ones(2, 1)*V(1,:));

	if (find(isnan(sol(:))) > 0)
		
		qa_1 = zeros(1, 0);
		kr_1 = zeros(1, 0);
	else		
		I = find(not(imag( sol(1,:) )));
		qa_1 = sol(1,I);
		kr_1 = sol(2,I);
	end
end
