function Data = DataPreparationDicta( input,ncam,lineNum)


for n=1:ncam
        
% Gt_pose_wc=[input.Camera(n).R input.Camera(n).t;0 0 0 1];
% [~, ~, ~,~,beta ,gamma] = rotAnglefromMatrix2 (Gt_pose_wc(1:3,1:3));    

Data(n).beta = input.Camera(n).vertical_direction(1);
Data(n).gamma = input.Camera(n).vertical_direction(2);   
    
% Data(n).beta = beta;
% Data(n).gamma = gamma;   

beta = Data(n).beta;
gamma = Data(n).gamma;

Ry=[cos(beta) 0 sin(beta); 0 1 0; -sin(beta) 0 cos(beta)];
Rz=[cos(gamma), -sin(gamma), 0; sin(gamma), cos(gamma), 0; 0, 0, 1];

Data(n).RV = Rz*Ry;

Pw_s = input.Camera(n).Line3D(:).start(1:lineNum,:)';
Pw_e = input.Camera(n).Line3D(:).end(1:lineNum,:)';

Vww=Pw_e-Pw_s;
Data(n).V = Vww ./ vecnorm(Vww);
Data(n).Pw_s = Pw_s;
Data(n).Pw_e = Pw_e;    
    
Data(n).xs = input.Camera(n).Line2D(:).start(1:lineNum,:)';
Data(n).xe = input.Camera(n).Line2D(:).end(1:lineNum,:)';

% Data(n).R_wc  = input.Camera(n).R;
% Data(n).T_wc  = input.Camera(n).t;

Vww2D1=Data(n).xe-Data(n).xs;
Directions2D1 = Vww2D1 ./ vecnorm(Vww2D1);
normals1=(cross(Directions2D1,Data(n).xs)) ./vecnorm(cross(Directions2D1,Data(n).xs));

Data(n).nc = normals1;


end



end
