function [A] = MatrixA_filling_minim2(input,RandomLine,q,it,CamIdx,Pw_s,Pw_si,nc,nci)

A = zeros(3*2,(2)*3+1);

index=1;
alpha_synth=q(1);
Rx = [1 0 0 ; 0 cos(alpha_synth) -sin(alpha_synth); 0 sin(alpha_synth) cos(alpha_synth)];
R = input(1).RV * Rx;

r11 =R(1,1);
r12 =R(1,2);
r13 =R(1,3);
r21 =R(2,1);
r22 =R(2,2);
r23 =R(2,3);
r31 =R(3,1);
r32 =R(3,2);
r33 =R(3,3);

for i=1:3
    

    x =Pw_s(1,RandomLine(it).lines(i));
    y =Pw_s(2,RandomLine(it).lines(i));
    z =Pw_s(3,RandomLine(it).lines(i));   
    
    n1 =nc(1,RandomLine(it).lines(i));
    n2 =nc(2,RandomLine(it).lines(i));
    n3 =nc(3,RandomLine(it).lines(i));   
    
    
    A(index,1) = n1;
    A(index,2) = n2;
    A(index,3) = n3;
    
    A(index,7) =n1 * r11 * x + n1 * r12 * y + n1 * r13 * z + n2 * r21 * x + n2 * r22 * y + n2 * r23 * z + n3 * r31 * x + n3 * r32 * y + n3 * r33 * z;        
    index=index+2;    
end


index=2;

    alpha_synth_r=q(2);
    
    Rxi = [1 0 0 ; 0 cos(alpha_synth_r) -sin(alpha_synth_r); 0 sin(alpha_synth_r) cos(alpha_synth_r)];
    Ri = input(CamIdx).RV * Rxi;

    
    ri11 =Ri(1,1);
    ri12 =Ri(1,2);
    ri13 =Ri(1,3);
    ri21 =Ri(2,1);
    ri22 =Ri(2,2);
    ri23 =Ri(2,3);
    ri31 =Ri(3,1);
    ri32 =Ri(3,2);
    ri33 =Ri(3,3);
    
    
    for i=1:3
        
        
        x =Pw_si(1,RandomLine(it).lines(i));
        y =Pw_si(2,RandomLine(it).lines(i));
        z =Pw_si(3,RandomLine(it).lines(i));          
        
        ni1 =nci(1,RandomLine(it).lines(i));
        ni2 =nci(2,RandomLine(it).lines(i));
        ni3 =nci(3,RandomLine(it).lines(i));   
                    
        A(index,1) = ni1 * ri11 + ni2 * ri21 + ni3 * ri31;
        A(index,2) = ni1 * ri12 + ni2 * ri22 + ni3 * ri32;
        A(index,3) = ni1 * ri13 + ni2 * ri23 + ni3 * ri33;
        A(index,4) = ni1;
        A(index,5) = ni2;
        A(index,6) = ni3;
        
%         A(index,7) = ni1 * r11 * ri11 * x ...
%             + ni1 * r12 * ri11 * y ...
%             + ni1 * r13 * ri11 * z ...
%             + ni1 * r21 * ri12 * x ...
%             + ni1 * r22 * ri12 * y ...
%             + ni1 * r23 * ri12 * z ...
%             + ni1 * r31 * ri13 * x ...
%             + ni1 * r32 * ri13 * y ...
%             + ni1 * r33 * ri13 * z ...
%             + ni2 * r11 * ri21 * x ...
%             + ni2 * r12 * ri21 * y ...
%             + ni2 * r13 * ri21 * z ...
%             + ni2 * r21 * ri22 * x ...
%             + ni2 * r22 * ri22 * y ...
%             + ni2 * r23 * ri22 * z ...
%             + ni2 * r31 * ri23 * x ...
%             + ni2 * r32 * ri23 * y ...
%             + ni2 * r33 * ri23 * z ...
%             + ni3 * r11 * ri31 * x ...
%             + ni3 * r12 * ri31 * y ...
%             + ni3 * r13 * ri31 * z ...
%             + ni3 * r21 * ri32 * x ...
%             + ni3 * r22 * ri32 * y ...
%             + ni3 * r23 * ri32 * z ...
%             + ni3 * r31 * ri33 * x ...
%             + ni3 * r32 * ri33 * y ...
%             + ni3 * r33 * ri33 * z;
        
        
        A(index,7) = ni1 * r11 * ri11 * x + ni1 * r12 * ri11 * y + ni1 * r13 * ri11 * z + ni1 * r21 * ri12 * x + ni1 * r22 * ri12 * y + ni1 * r23 * ri12 * z + ni1 * r31 * ri13 * x + ni1 * r32 * ri13 * y + ni1 * r33 * ri13 * z + ni2 * r11 * ri21 * x + ni2 * r12 * ri21 * y + ni2 * r13 * ri21 * z + ni2 * r21 * ri22 * x + ni2 * r22 * ri22 * y + ni2 * r23 * ri22 * z + ni2 * r31 * ri23 * x + ni2 * r32 * ri23 * y + ni2 * r33 * ri23 * z + ni3 * r11 * ri31 * x + ni3 * r12 * ri31 * y + ni3 * r13 * ri31 * z + ni3 * r21 * ri32 * x + ni3 * r22 * ri32 * y + ni3 * r23 * ri32 * z + ni3 * r31 * ri33 * x + ni3 * r32 * ri33 * y + ni3 * r33 * ri33 * z;        
        
        
        index=index+2;
        
    end
    
    



end

