function [Translation_all] = Translation_solver_min(input,RandomLine,q_listes_all,camNum,iterations)

Translation_all = struct;

for CamIdx=1:camNum-1
    
    for it=1:iterations
        
        solution=length(q_listes_all(CamIdx).q_listes(it).alpha);
        Translation_solutions.combination = zeros(2,solution*solution);
        Translation_solutions.translation = zeros(6,solution*solution);
        
        ind = 1;
        for sol=1:solution
            for sol2=1:solution
                
                
                q(1) = q_listes_all(CamIdx).q_listes(it).alpha(1,sol);
                q(2) = q_listes_all(CamIdx).q_listes(it).alpha(2,sol2);
                
                Translation_solutions.combination(1,ind) = q(1);
                Translation_solutions.combination(2,ind) = q(2);
                
                Pw_s  = input(1).Pw_s;
                Pw_si  =input(CamIdx+1).Pw_s;

                nc =input(1).nc;        
                nci =input(CamIdx+1).nc;
                 
                
                
                
                [A] =MatrixA_filling_minim2(input,RandomLine,q,it,(CamIdx+1),Pw_s,Pw_si,nc,nci);
                %[A2] =MatrixA_filling_minim(input,RandomLine,q,it,(CamIdx+1));
                
                
                [~,~,V] = svd(A);
                
                vec = V(:,end);
                vec = vec/vec(end);
                t_liste=vec(1:end-1)';
                
                
                %absolute Translation Error
                Translation_solutions.translation(1,ind) = t_liste(1);
                Translation_solutions.translation(2,ind) = t_liste(2);
                Translation_solutions.translation(3,ind) = t_liste(3);
                
                %Relative Translation Error
                Translation_solutions.translation(4,ind) = t_liste(4);
                Translation_solutions.translation(5,ind) = t_liste(5);
                Translation_solutions.translation(6,ind) = t_liste(6);
                
                %                 clear fun root2d_translation
                %                 clear root2d_translation
                %                 clear A
                
                ind = ind + 1;
            end
        end
        
        Translation_all(CamIdx).t_sols(it).t = Translation_solutions;
    end
end

end

