function [Poses] = mv_pose_vd(input,camNum,lineNum,iterations)



% Preparation of the input for the solver
RandomLine = LineSelecting(lineNum,iterations);

% ------------------------------------------------------------------
D = DataPreparationDicta( input,camNum,lineNum);

% calling the solver 
% ------------------------------------------------------------------
[Poses] = mv_pose_vd_LM_Solver(D,RandomLine,lineNum,camNum,iterations);

% Returning the pose{1,1} (world coordinate system to camera) 
% Returning the poses{1,:}  (Relative pose from the reference camera to the other cameras) 

% ------------------------------------------------------------------
if isnan(Poses{1,1}(1:3,1:3))
    warning('No solution can be found! please check your data.');
end


end

