function [DirectSolver_Checking_all] = ValidatePoses_GimLee2(input,q_listes_all,Translation_all,camNum,iterations)

%input,q_listes_all,Translation_all,camNum,iterations

DirectSolver_Checking_all = struct;

for CamIdx=1:camNum-1
    
    DirectSolver_Valide_solutions=struct;
    DirectSolver_solutions=struct;
    DirectSolver_Checking=struct;
    DirectSolver_solutions.R1 = [];
    
    minimalReprojectionError = 10000000;
    for it=1:iterations
        
        
        solution=length(q_listes_all(CamIdx).q_listes(it).alpha);

        DirectSolver_Valide_solutions.rotation = zeros(2,solution);
        DirectSolver_Valide_solutions.translation = zeros(2*3,solution);
        DirectSolver_Valide_solutions.Point = zeros(2*3,solution);
        DirectSolver_Valide_solutions.reprojectionE = zeros(1,solution);
        
        if(~isempty(q_listes_all(CamIdx).q_listes(it).alpha))
            
            averagetresh = zeros(1,solution);
            

            ind = 1;
            
            Rel = struct;
            for sol=1:solution
                for so2=1:solution
                                
                Abs_alpha = Translation_all(CamIdx).t_sols(it).t.combination(1,ind);
                Abs_Rx = [1 ,0 ,0 ; 0 ,cos(Abs_alpha), -sin(Abs_alpha); 0 ,sin(Abs_alpha), cos(Abs_alpha)];
                Abs_tran = Translation_all(CamIdx).t_sols(it).t.translation(1:3,ind);
                Abs_Rota = input(1).RV*Abs_Rx;
                Abs_Pose = [(input(1).RV*Abs_Rx) Abs_tran ; 0 0 0 1];
                
                
                Cidx=1;
                Rel(Cidx).alpha = Translation_all(CamIdx).t_sols(it).t.combination(Cidx+1,ind);
                Rel(Cidx).Rx = [1 ,0 ,0 ; 0 ,cos(Rel(Cidx).alpha), -sin(Rel(Cidx).alpha); 0 ,sin(Rel(Cidx).alpha), cos(Rel(Cidx).alpha)];
                Rel(Cidx).tran = Translation_all(CamIdx).t_sols(it).t.translation(1+Cidx*3:(Cidx+1)*3,ind);
                Rel(Cidx).Rota = input(CamIdx+1).RV*Rel(Cidx).Rx*Abs_Rota;
                Rel(Cidx).Pose = [(input(CamIdx+1).RV*Rel(Cidx).Rx) Rel(Cidx).tran ; 0 0 0 1]*Abs_Pose;
                pose_estimated_Rel_cc = [(input(CamIdx+1).RV*Rel(Cidx).Rx) Rel(Cidx).tran ; 0 0 0 1];
                
                pose_estimated = [Abs_Rota Abs_tran; 0 0 0 1];
                pose_estimated_Rel = [Rel(Cidx).Rota Rel(Cidx).tran; 0 0 0 1];
                
                pose_Abs{ind} = pose_estimated;
                pose_Rel{ind} = pose_estimated_Rel;
                
                pose_alpha_Abs{ind} = Abs_alpha;
                pose_Translation_Abs{ind} = Abs_tran;
                
                pose_alpha_Rel{ind} = Rel(Cidx).alpha;
                pose_Translation_Rel{ind} = Rel(Cidx).tran;
                
                
                
                %% Absolute backprojection
                %%-------------------------------------------------------------------------------
                
                S3D=vertcat(input(1).Pw_s)';
                E3D=vertcat(input(1).Pw_e)';
                V3D=vertcat(input(1).V)';                
                
                
                S2D=horzcat(input(1).xs)';
                E2D=horzcat(input(1).xe)';
                N2D=horzcat(input(1).nc)';                
                
                ArrayData (:,1) = S2D(:,1);
                ArrayData (:,2) = S2D(:,2);
                ArrayData (:,3) = S2D(:,3);
                
                ArrayData (:,4) = E2D(:,1);
                ArrayData (:,5) = E2D(:,2);
                ArrayData (:,6) = E2D(:,3);
                
                ArrayData (:,7) = S3D(:,1);
                ArrayData (:,8) = S3D(:,2);
                ArrayData (:,9) = S3D(:,3);
                
                ArrayData (:,10) = E3D(:,1);
                ArrayData (:,11) = E3D(:,2);
                ArrayData (:,12) = E3D(:,3);
                

                [line_error] = Back_projection_error_GimLee3(pose_estimated,S2D,E2D,S3D,E3D);
                
                line_error_all_Abs(ind) = sum(line_error);
                
                
                Zchecking1 = pose_estimated * [S3D' ;ones(1,size(S3D',2))];
                Zchecking2 = pose_estimated * [E3D' ;ones(1,size(E3D',2))];
                
                if(min(Zchecking1(3,:))<0 || min(Zchecking2(3,:))<0)
                    line_error_all_Abs(ind) = line_error_all_Abs(ind) + 100000;
                end
                
                %% Relative backprojection
                %%-------------------------------------------------------------------------------               
                
                S2D=horzcat(input(CamIdx+1).xs)';
                E2D=horzcat(input(CamIdx+1).xe)';
                N2D=horzcat(input(CamIdx+1).nc)';                  
                
                
                S3D = pose_estimated * [S3D' ;ones(1,size(S3D',2))];
                E3D = pose_estimated * [E3D' ;ones(1,size(E3D',2))];                
                
                S3D_1 = S3D(1:3,:)./S3D(4,:);                
                E3D_1 = E3D(1:3,:)./E3D(4,:);                
                
                S3D=S3D_1(1:3,:)';
                E3D=E3D_1(1:3,:)';

                ArrayData (:,1) = S2D(:,1);
                ArrayData (:,2) = S2D(:,2);
                ArrayData (:,3) = S2D(:,3);
                
                ArrayData (:,4) = E2D(:,1);
                ArrayData (:,5) = E2D(:,2);
                ArrayData (:,6) = E2D(:,3);
                
                ArrayData (:,7) = S3D(:,1);
                ArrayData (:,8) = S3D(:,2);
                ArrayData (:,9) = S3D(:,3);
                
                ArrayData (:,10) = E3D(:,1);
                ArrayData (:,11) = E3D(:,2);
                ArrayData (:,12) = E3D(:,3);
                                
                [line_error_Rel] = Back_projection_error_GimLee3(pose_estimated_Rel_cc,S2D,E2D,S3D,E3D);
                
                
                
                line_error_all_Rel(ind) = sum(line_error_Rel);
                
                Zchecking1 = pose_estimated_Rel_cc * [S3D' ;ones(1,size(S3D',2))];
                Zchecking2 = pose_estimated_Rel_cc * [E3D' ;ones(1,size(E3D',2))];
                
                if(min(Zchecking1(3,:))<0 || min(Zchecking2(3,:))<0)
                    line_error_all_Rel(ind) = line_error_all_Rel(ind) + 100000;
                end
                
                
                %%
                %%-------------------------------------------------------------------------------
                averagetresh(1,ind)= line_error_all_Rel(ind) + line_error_all_Abs(ind);
                
                
                
                ind = ind + 1;
                end  
            end
            
            [Backprojection,Idx] = min(averagetresh);
            
            poseA =( pose_Abs{Idx});
            poseR =( pose_Rel{Idx});
            
            alpha_Abs =  pose_alpha_Abs{Idx};
            Translation_Abs =  pose_Translation_Abs{Idx};
            
            alpha_Rel =  pose_alpha_Rel{Idx};
            Translation_Rel =  pose_Translation_Rel{Idx};
            
            
            
            if Backprojection < minimalReprojectionError
            
            DirectSolver_solutions.R1 = alpha_Abs ;
            DirectSolver_solutions.R2 = alpha_Rel ;
            
            DirectSolver_solutions.t1 = Translation_Abs(1);
            DirectSolver_solutions.t2 = Translation_Abs(2);
            DirectSolver_solutions.t3 = Translation_Abs(3);
            
            DirectSolver_solutions.t4 = Translation_Rel(1);
            DirectSolver_solutions.t5 = Translation_Rel(2);
            DirectSolver_solutions.t6 = Translation_Rel(3);
            
            DirectSolver_Checking.Rotation = [alpha_Abs;alpha_Rel];
            DirectSolver_Checking.Translation = [Translation_Abs ; Translation_Rel ];
            
            minimalReprojectionError = Backprojection;
            
        end
        
    end
    
end


DirectSolver_Checking_all(CamIdx).DirectSolver_solutions = DirectSolver_solutions;
DirectSolver_Checking_all(CamIdx).DirectSolver_Checking = DirectSolver_Checking;

end


