function [q_listes_all] = Solver_Main_nc(input,RandomLine,camNum,iterations)

q_listes_all = struct;

for CamIdx=2:camNum
    
    q_listes = struct;
    RVa = input(1).RV;
    RVb = input(CamIdx).RV;
        
    for it=1:iterations
        
        unit1 = input(1).V(:,RandomLine(it).lines);
        unit2 = input(CamIdx).V(:,RandomLine(it).lines);
        n1_1a = input(1).nc(:,RandomLine(it).lines);
        n1_2b = input(CamIdx).nc(:,RandomLine(it).lines);
                
        [solution] = Solver_Main_2c(RVa,RVb,unit1,unit2,n1_1a,n1_2b);        
        q_listes(it).alpha = solution.alpha;
        q_listes(it).degree = solution.degree;
        q_listes(it).No_Solution = solution.No_Solution;
        q_listes(it).q = solution.q;
        
%         for k=1:size(solution.alpha,2)
%         list(k).R = rotMfromAngleRad3 (solution.alpha(1,k), input(1).beta, input(1).gamma);
%         list2(k).R = rotMfromAngleRad3 (solution.alpha(2,k), input(CamIdx).beta, input(CamIdx).gamma);        
%         
%         end
%         q_listes(it).R1 = list;
%         q_listes(it).R2 = list2;
        
        
    end

    q_listes_all(CamIdx-1).q_listes = q_listes;
    
end

end

