function c = crossfast(a,b,dim)

    perm = [dim:max(length(size(a)),dim) 1:dim-1];
    a = permute(a,perm);
    b = permute(b,perm);
    
    % Calculate cross product
    c(3,:) = a(1,:).*b(2,:)-a(2,:).*b(1,:);
    c(1,:) = a(2,:).*b(3,:)-a(3,:).*b(2,:);
    c(2,:) = a(3,:).*b(1,:)-a(1,:).*b(3,:);
    c = reshape(c,size(a))';
    
end