function F = EquationConstruct_fast2(x,input,CameraNum,LineNum)

num = LineNum;
F_index=0;
Rv = input(1).RV;
 
rv11 =Rv(1,1);
rv12 =Rv(1,2);
rv13 =Rv(1,3);

rv21 =Rv(2,1);
rv22 =Rv(2,2);
rv23 =Rv(2,3);

rv31 =Rv(3,1);
rv32 =Rv(3,2);
rv33 =Rv(3,3);

qa=    x(1);
index=1;
 
        
    v1 =input(1).V(1,:);
    v2 =input(1).V(2,:);
    v3 =input(1).V(3,:);
    
    n1 =input(1).nc(1,:);
    n2 =input(1).nc(2,:);
    n3 =input(1).nc(3,:);        
        
        

F(F_index+1:F_index+num) =    0.2e1 .* (((n1 .* rv11 .* (qa .^ 2 + 1) + n2 .* rv21 .* (qa .^ 2 + 1) + n3 .* rv31 .* (qa .^ 2 + 1)) .* v1) + (n1 .* ((rv12 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv13 .* qa) + n2 .* ((rv22 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv23 .* qa) + n3 .* ((rv32 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv33 .* qa)) .* v2 + (n1 .* (-0.2e1 .* rv12 .* qa + (rv13 .* (-qa .^ 2 + 1))) + n2 .* (-0.2e1 .* rv22 .* qa + (rv23 .* (-qa .^ 2 + 1))) + n3 .* (-0.2e1 .* rv32 .* qa + (rv33 .* (-qa .^ 2 + 1)))) .* v3) .* (((2 .* n1 .* qa .* rv11 + 2 .* n2 .* qa .* rv21 + 2 .* n3 .* qa .* rv31) .* v1) + (n1 .* (-(2 .* rv12 .* qa) + 0.2e1 .* rv13) + n2 .* (-(2 .* rv22 .* qa) + 0.2e1 .* rv23) + n3 .* (-(2 .* rv32 .* qa) + 0.2e1 .* rv33)) .* v2 + (n1 .* (-0.2e1 .* rv12 - (2 .* rv13 .* qa)) + n2 .* (-0.2e1 .* rv22 - (2 .* rv23 .* qa)) + n3 .* (-0.2e1 .* rv32 - (2 .* rv33 .* qa))) .* v3);

F_index = F_index  + num;        
        


for j=1:CameraNum-1
    
    kr=x(j+1);
    Rvi = input(j+1).RV;    
    riv11 =Rvi(1,1);
    riv12 =Rvi(1,2);
    riv13 =Rvi(1,3);
    riv21 =Rvi(2,1);
    riv22 =Rvi(2,2);
    riv23 =Rvi(2,3);
    riv31 =Rvi(3,1);
    riv32 =Rvi(3,2);
    riv33 =Rvi(3,3);
    

        ni1 =input(j+1).nc(1,:);
        ni2 =input(j+1).nc(2,:);
        ni3 =input(j+1).nc(3,:);        
        
        
    F(F_index+1:F_index+num) = 0.2e1 .* ((((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* rv11 .* (qa .^ 2 + 1)) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* rv21 .* (qa .^ 2 + 1) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* rv31 .* (qa .^ 2 + 1)) .* v1 + ((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* ((rv12 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv13 .* qa) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* ((rv22 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv23 .* qa) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* ((rv32 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv33 .* qa)) .* v2 + ((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* (-0.2e1 .* rv12 .* qa + (rv13 .* (-qa .^ 2 + 1))) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* (-0.2e1 .* rv22 .* qa + (rv23 .* (-qa .^ 2 + 1))) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* (-0.2e1 .* rv32 .* qa + (rv33 .* (-qa .^ 2 + 1)))) .* v3) .* (((2 .* (ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* rv11 .* qa) + 0.2e1 .* (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* rv21 .* qa + 0.2e1 .* (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* rv31 .* qa) .* v1 + ((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* (-(2 .* rv12 .* qa) + 0.2e1 .* rv13) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* (-(2 .* rv22 .* qa) + 0.2e1 .* rv23) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* (-(2 .* rv32 .* qa) + 0.2e1 .* rv33)) .* v2 + ((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* (-0.2e1 .* rv12 - (2 .* rv13 .* qa)) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* (-0.2e1 .* rv22 - (2 .* rv23 .* qa)) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* (-0.2e1 .* rv32 - (2 .* rv33 .* qa))) .* v3);
    F_index = F_index  + num;
    
    F(F_index+1:F_index+num) = 0.2e1 .* ((((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* rv11 .* (qa .^ 2 + 1)) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* rv21 .* (qa .^ 2 + 1) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* rv31 .* (qa .^ 2 + 1)) .* v1 + ((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* ((rv12 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv13 .* qa) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* ((rv22 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv23 .* qa) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* ((rv32 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv33 .* qa)) .* v2 + ((ni1 .* riv11 .* (kr .^ 2 + 1) + ni2 .* riv21 .* (kr .^ 2 + 1) + ni3 .* riv31 .* (kr .^ 2 + 1)) .* (-0.2e1 .* rv12 .* qa + (rv13 .* (-qa .^ 2 + 1))) + (ni1 .* ((riv12 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv13 .* kr) + ni2 .* ((riv22 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv23 .* kr) + ni3 .* ((riv32 .* (-kr .^ 2 + 1)) + 0.2e1 .* riv33 .* kr)) .* (-0.2e1 .* rv22 .* qa + (rv23 .* (-qa .^ 2 + 1))) + (ni1 .* (-0.2e1 .* riv12 .* kr + (riv13 .* (-kr .^ 2 + 1))) + ni2 .* (-0.2e1 .* riv22 .* kr + (riv23 .* (-kr .^ 2 + 1))) + ni3 .* (-0.2e1 .* riv32 .* kr + (riv33 .* (-kr .^ 2 + 1)))) .* (-0.2e1 .* rv32 .* qa + (rv33 .* (-qa .^ 2 + 1)))) .* v3) .* ((((2 .* kr .* ni1 .* riv11 + 2 .* kr .* ni2 .* riv21 + 2 .* kr .* ni3 .* riv31) .* rv11 .* (qa .^ 2 + 1)) + (ni1 .* (-(2 .* riv12 .* kr) + 0.2e1 .* riv13) + ni2 .* (-(2 .* riv22 .* kr) + 0.2e1 .* riv23) + ni3 .* (-(2 .* riv32 .* kr) + 0.2e1 .* riv33)) .* rv21 .* (qa .^ 2 + 1) + (ni1 .* (-0.2e1 .* riv12 - (2 .* riv13 .* kr)) + ni2 .* (-0.2e1 .* riv22 - (2 .* riv23 .* kr)) + ni3 .* (-0.2e1 .* riv32 - (2 .* riv33 .* kr))) .* rv31 .* (qa .^ 2 + 1)) .* v1 + ((2 .* kr .* ni1 .* riv11 + 2 .* kr .* ni2 .* riv21 + 2 .* kr .* ni3 .* riv31) .* ((rv12 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv13 .* qa) + (ni1 .* (-(2 .* riv12 .* kr) + 0.2e1 .* riv13) + ni2 .* (-(2 .* riv22 .* kr) + 0.2e1 .* riv23) + ni3 .* (-(2 .* riv32 .* kr) + 0.2e1 .* riv33)) .* ((rv22 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv23 .* qa) + (ni1 .* (-0.2e1 .* riv12 - (2 .* riv13 .* kr)) + ni2 .* (-0.2e1 .* riv22 - (2 .* riv23 .* kr)) + ni3 .* (-0.2e1 .* riv32 - (2 .* riv33 .* kr))) .* ((rv32 .* (-qa .^ 2 + 1)) + 0.2e1 .* rv33 .* qa)) .* v2 + ((2 .* kr .* ni1 .* riv11 + 2 .* kr .* ni2 .* riv21 + 2 .* kr .* ni3 .* riv31) .* (-0.2e1 .* rv12 .* qa + (rv13 .* (-qa .^ 2 + 1))) + (ni1 .* (-(2 .* riv12 .* kr) + 0.2e1 .* riv13) + ni2 .* (-(2 .* riv22 .* kr) + 0.2e1 .* riv23) + ni3 .* (-(2 .* riv32 .* kr) + 0.2e1 .* riv33)) .* (-0.2e1 .* rv22 .* qa + (rv23 .* (-qa .^ 2 + 1))) + (ni1 .* (-0.2e1 .* riv12 - (2 .* riv13 .* kr)) + ni2 .* (-0.2e1 .* riv22 - (2 .* riv23 .* kr)) + ni3 .* (-0.2e1 .* riv32 - (2 .* riv33 .* kr))) .* (-0.2e1 .* rv32 .* qa + (rv33 .* (-qa .^ 2 + 1)))) .* v3);
    F_index = F_index  + num ;       
    
   


end

