function [q_listes_LS] = LeastSquaresSolver(input,Valide_All,lineNum,camNum)


q_listes_LS=struct;

x0=zeros(1,camNum-1);

for CamIdx=1:camNum-1

    
    x0(1)=x0(1)+Valide_All(CamIdx).DirectSolver_Checking.Rotation(1);
    x0(CamIdx+1)=Valide_All(CamIdx).DirectSolver_Checking.Rotation(2);

end                           
    

fun = @(x)EquationConstruct_fast2(x,input,camNum,lineNum);

x0(1)=x0(1)/(camNum-1);
x0 = tan(x0/2);



if(~isempty(x0))
    
    optOptions=optimset('Algorithm','Levenberg-Marquardt');
    optOptions.MaxFunEvals=3000;
    optOptions.LineSearchType = 'quadcubic';
    optOptions.TolX = 0.0000000001;
    optOptions.TolFun = 0.0000000001;
    optOptions.MaxIter = 1000;
    optOptions.Display = 'off';
    
    x = fsolve(fun,x0,optOptions);
    
    q_listes_LS.q = x;
    q_listes_LS.alpha = 2*atan(x);
    q_listes_LS.angle = 2*atan(x)*180/pi;
%     q_listes_LS.error = (abs(2*atan([DS_data.Camera(1:DS_data.CamNum).q]') - q_listes_LS.alpha(:)))*180/pi;
    q_listes_LS.Initq = x0;
    q_listes_LS.IniAngle = 2*atan(x0)*180/pi;
    
    
else
    q_listes_LS.q = [];
end


 

end

